<?php
          // Keeps file coded in UTF-8 without BOM : é
include_once (LCAS_PATH.'include/constants.php');
load_language('plugin.lang', LCAS_PATH);


/*
 * Splits a multi-byte string in a array of each of its characters.
 * Many thanks to adjwilli in
 * http://www.php.net/manual/fr/function.mb-split.php#80046
 *
 * @param string s: string to split
 *
 * @return : array of each character of s
*/
function LCAS_mbStringToArray($s) {
  $l = mb_strlen($s); $a = array();
  while ($l) {
    $a[] = mb_substr($s, 0, 1, 'UTF-8');
    $s = mb_substr($s, 1, $l, 'UTF-8');
    $l = mb_strlen($s);
  }
  return $a;
}



/*
 * Changes the characters of the given string as stated by values of
 * $conf['insensitive_case_logon'] and $LCAS_lang['char_replacement_set'].
 *
 * @param mix s: string, or array of strings, to evaluate
 *
 * @return : string, or array of strings, modified as stated
*/
function LCAS_change_case($Username, $Conf)
{
  $LCAS_lang                         = array();
  $LCAS_lang['char_replacement_set'] = array();



  // 0 : case sensitive, accents sensitive
  $LCAS_lang['char_replacement_set'][1] = array(
  // 1 : case insensitive, accents sensitive
    
  // Latin
    
    'a'  => 'A',
    'à'  => 'À',
    'â'  => 'Â',
    'á'  => 'Á',
    'ã'  => 'Ã',
    'ä'  => 'Ä',
    'å'  => 'Å',
    'ā'  => 'Ā',
    'ă'  => 'Ă',
    'ą'  => 'Ą',
    'ǻ'  => 'Ǻ',
    'ạ'  => 'Ạ',
    'ả'  => 'Ả',
    'ấ'  => 'Ấ',
    'ầ'  => 'Ầ',
    'ẩ'  => 'Ẩ',
    'ẫ'  => 'Ẫ',
    'ậ'  => 'Ậ',
    'ắ'  => 'Ắ',
    'ằ'  => 'Ằ',
    'ẳ'  => 'Ẳ',
    'ẵ'  => 'Ẵ',
    'ặ'  => 'Ặ',
    
    'b'  => 'B',
    
    'c'  => 'C',
    'ç'  => 'Ç',
    'ć'  => 'Ć',
    'ĉ'  => 'Ĉ',
    'ċ'  => 'Ċ',
    'č'  => 'Č',

    'd'  => 'D',
    'ď'  => 'Ď',
    'đ'  => 'Đ',
    
    'e'  => 'E',
    'è'  => 'È',
    'é'  => 'É',
    'ê'  => 'Ê',
    'ë'  => 'Ë',
    'ē'  => 'Ē',
    'ĕ'  => 'Ĕ',
    'ė'  => 'Ė',
    'ę'  => 'Ę',
    'ě'  => 'Ě',
    'ẹ'  => 'Ẹ',
    'ẻ'  => 'Ẻ',
    'ẽ'  => 'Ẽ',
    'ế'  => 'Ế',
    'ề'  => 'Ề',
    'ể'  => 'Ể',
    'ễ'  => 'Ễ',
    'ệ'  => 'Ệ',
    
    'f'  => 'F ƒ',
    
    'g'  => 'G',
    'ĝ'  => 'Ĝ',
    'ğ'  => 'Ğ',
    'ġ'  => 'Ġ',
    'ģ'  => 'Ģ',
    
    'h'  => 'H',
    'ĥ'  => 'Ĥ',
    'ħ'  => 'Ħ',
    
    'i'  => 'I ı İ',
    'ì'  => 'Ì',
    'í'  => 'Í',
    'î'  => 'Î',
    'ï'  => 'Ï',
    'ĩ'  => 'Ĩ',
    'ī'  => 'Ī',
    'ĭ'  => 'Ĭ',
    'į'  => 'Į',
    'ǐ'  => 'Ǐ',
    'ỉ'  => 'Ỉ',
    'ị'  => 'Ị',
    
    'j'  => 'J',
    'ĵ'  => 'Ĵ',
    
    'k'  => 'K',
    'ķ'  => 'Ķ',
    
    'l'  => 'L',
    'ĺ'  => 'Ĺ',
    'ļ'  => 'Ļ',
    'ľ'  => 'Ľ',
    'ŀ'  => 'Ŀ',
    'ł'  => 'Ł',
    
    'm'  => 'M',
    
    'n'  => 'N',
    'ñ'  => 'Ñ',
    'ń'  => 'Ń',
    'ņ'  => 'Ņ',
    'ň'  => 'Ň',
    
    'o'  => 'O',
    'ò'  => 'Ò',
    'ó'  => 'Ó',
    'ô'  => 'Ô',
    'õ'  => 'Õ',
    'ö'  => 'Ö',
    'ø'  => 'Ø',
    'ō'  => 'Ō',
    'ŏ'  => 'Ŏ',
    'ő'  => 'Ő',
    'ơ'  => 'Ơ',
    'ǒ'  => 'Ǒ',
    'ǿ'  => 'Ǿ',
    'ọ'  => 'Ọ',
    'ỏ'  => 'Ỏ',
    'ố'  => 'Ố',
    'ồ'  => 'Ồ',
    'ổ'  => 'Ổ',
    'ỗ'  => 'Ỗ',
    'ộ'  => 'Ộ',
    'ớ'  => 'Ớ',
    'ờ'  => 'Ờ',
    'ở'  => 'Ở',
    'ỡ'  => 'Ỡ',
    'ợ'  => 'Ợ',
    
    'p'  => 'P',
    
    'q'  => 'Q ĸ',
    
    'r'  => 'R',
    'ŕ'  => 'Ŕ',
    'ŗ'  => 'Ŗ',
    'ř'  => 'Ř',
    
    's'  => 'S ſ',
    'ś'  => 'Ś',
    'ŝ'  => 'Ŝ',
    'ş'  => 'Ş',
    'š'  => 'Š',
    'ss' => 'ß',
    
    't'  => 'T',
    'ţ'  => 'Ţ',
    'ť'  => 'Ť',
    'ŧ'  => 'Ŧ',
    
    'u'  => 'U',
    'ù'  => 'Ù',
    'ú'  => 'Ú',
    'û'  => 'Û',
    'ü'  => 'Ü',
    'ũ'  => 'Ũ',
    'ū'  => 'Ū',
    'ŭ'  => 'Ŭ',
    'ů'  => 'Ů',
    'ű'  => 'Ű',
    'ų'  => 'Ų',
    'ǔ'  => 'Ǔ',
    'ǖ'  => 'Ǖ',
    'ǘ'  => 'Ǘ',
    'ǚ'  => 'Ǚ',
    'ǜ'  => 'Ǜ',
    'ư'  => 'Ư',
    'ụ'  => 'Ụ',
    'ủ'  => 'Ủ',
    'ứ'  => 'Ứ',
    'ừ'  => 'Ừ',
    'ử'  => 'Ử',
    'ữ'  => 'Ữ',
    'ự'  => 'Ự',
    
    'v'  => 'V',
    
    'w'  => 'W',
    'ŵ'  => 'Ŵ',
    'ẁ'  => 'Ẁ',
    'ẃ'  => 'Ẃ',
    'ẅ'  => 'Ẅ',
    
    'x'  => 'X',
    
    'y'  => 'Y',
    'ý'  => 'Ý',
    'ÿ'  => 'Ÿ',
    'ỳ'  => 'Ỳ',
    'ỵ'  => 'Ỵ',
    'ỷ'  => 'Ỷ',
    'ỹ'  => 'Ỹ',
    'ŷ'  => 'Ŷ',
    
    'z'  => 'Z',
    'ź'  => 'Ź',
    'ż'  => 'Ż',
    'ž'  => 'Ž',
    
    'ae' => 'æ Æ',
    'aé' => 'ǽ Ǽ',
    'ð'  => 'Ð',
    'ə'  => 'Ə',
    'ij' => 'ĳ Ĳ',
    'ŋ'  => 'Ŋ',
    'oe' => 'œ Œ',
    'þ'  => 'Þ',
    
  // Greek
    
    'α'  => 'Α',
    'ά'  => 'Ά',
    'β'  => 'Β',
    'γ'  => 'Γ',
    'δ'  => 'Δ',
    'ε'  => 'Ε',
    'έ'  => 'Έ',
    'ζ'  => 'Ζ',
    'η'  => 'Η',
    'ή'  => 'Ή',
    'θ'  => 'Θ',
    'ι'  => 'Ι',
    'ί'  => 'Ί',
    'ϊ'  => 'Ϊ',
    'κ'  => 'Κ',
    'λ'  => 'Λ',
    'μ'  => 'Μ µ',
    'ν'  => 'Ν',
    'ξ'  => 'Ξ',
    'ο'  => 'Ο',
    'ό'  => 'Ό',
    'π'  => 'Π',
    'ρ'  => 'Ρ',
    'σ'  => 'Σ ς',
    'τ'  => 'Τ',
    'υ'  => 'Υ',
    'ύ'  => 'Ύ',
    'ϋ'  => 'Ϋ',
    'φ'  => 'Φ',
    'χ'  => 'Χ',
    'ψ'  => 'Ψ',
    'ω'  => 'Ω',
    'ώ'  => 'Ώ',
    
  // Cyrillic
    
    'а'  => 'А',
    'б'  => 'Б',
    'в'  => 'В',
    'г'  => 'Г',
    'ґ'  => 'Ґ',
    'ғ'  => 'Ғ',
    'д'  => 'Д',
    'е'  => 'Е',
    'ж'  => 'Ж',
    'җ'  => 'Җ',
    'з'  => 'З',
    'и'  => 'И',
    'й'  => 'Й',
    'к'  => 'К',
    'қ'  => 'Қ',
    'ҝ'  => 'Ҝ',
    'л'  => 'Л',
    'м'  => 'М',
    'н'  => 'Н',
    'ң'  => 'Ң',
    'о'  => 'О',
    'п'  => 'П',
    'р'  => 'Р',
    'с'  => 'С',
    'т'  => 'Т',
    'у'  => 'У',
    'ү'  => 'Ү',
    'ұ'  => 'Ұ',
    'ф'  => 'Ф',
    'х'  => 'Х',
    'ҳ'  => 'Ҳ',
    'ц'  => 'Ц',
    'ч'  => 'Ч',
    'ҹ'  => 'Ҹ',
    'ш'  => 'Ш',
    'щ'  => 'Щ',
    'ъ'  => 'Ъ',
    'ы'  => 'Ы',
    'ь'  => 'Ь',
    'э'  => 'Э',
    'ю'  => 'Ю',
    'я'  => 'Я',
    'ё'  => 'Ё',
    'ђ'  => 'Ђ',
    'ѓ'  => 'Ѓ',
    'є'  => 'Є',
    'ѕ'  => 'Ѕ',
    'і'  => 'І',
    'ї'  => 'Ї',
    'ј'  => 'Ј',
    'љ'  => 'Љ',
    'њ'  => 'Њ',
    'ћ'  => 'Ћ',
    'ќ'  => 'Ќ',
    'ў'  => 'Ў',
    'џ'  => 'Џ',
    'һ'  => 'Һ',
    'ә'  => 'Ә',
    'ө'  => 'Ө',
    
  );

  $LCAS_lang['char_replacement_set'][2] = array(
  // 2 : case insensitive, accents insensitive
    
  // Latin
    
    'a'  => 'A à À â Â á Á ã Ã ä Ä å Å ā Ā ă Ă ą Ą ǻ Ǻ ạ Ạ ả Ả ấ Ấ ầ Ầ ẩ Ẩ ẫ Ẫ ậ Ậ ắ Ắ ằ Ằ ẳ Ẳ ẵ Ẵ ặ Ặ @',
    'b'  => 'B',
    'c'  => 'C ç Ç ć Ć ĉ Ĉ ċ Ċ č Č',
    'd'  => 'D ď Ď đ Đ',
    'e'  => 'E è È é É ê Ê ë Ë ē Ē ĕ Ĕ ė Ė ę Ę ě Ě ẹ Ẹ ẻ Ẻ ẽ Ẽ ế Ế ề Ề ể Ể ễ Ễ ệ Ệ',
    'f'  => 'F ƒ',
    'g'  => 'G ĝ Ĝ ğ Ğ ġ Ġ ģ Ģ',
    'h'  => 'H ĥ Ĥ ħ Ħ',
    'i'  => 'I ı İ ì Ì í Í î Î ï Ï ĩ Ĩ ī Ī ĭ Ĭ į Į ǐ Ǐ ỉ Ỉ ị Ị',
    'j'  => 'J ĵ Ĵ',
    'k'  => 'K ķ Ķ',
    'l'  => 'L ĺ Ĺ ļ Ļ ľ Ľ ŀ Ŀ ł Ł',
    'm'  => 'M',
    'n'  => 'N ŉ ñ Ñ ń Ń ņ Ņ ň Ň',
    'o'  => 'O ò Ò ó Ó ô Ô õ Õ ö Ö ø Ø ō Ō ŏ Ŏ ő Ő ơ Ơ ǒ Ǒ ǿ Ǿ ọ Ọ ỏ Ỏ ố Ố ồ Ồ ổ Ổ ỗ Ỗ ộ Ộ ớ Ớ ờ Ờ ở Ở ỡ Ỡ ợ Ợ',
    'p'  => 'P',
    'q'  => 'Q ĸ',
    'r'  => 'R ŕ Ŕ ŗ Ŗ ř Ř',
    's'  => 'S ś Ś ŝ Ŝ ş Ş š Š s ſ',
    'ss' => 'ß',
    't'  => 'T ţ Ţ ť Ť ŧ Ŧ',
    'u'  => 'U ù Ù ú Ú û Û ü Ü ũ Ũ ū Ū ŭ Ŭ ů Ů ű Ű ų Ų ǔ Ǔ ǖ Ǖ ǘ Ǘ ǚ Ǚ ǜ Ǜ ư Ư ụ Ụ ủ Ủ ứ Ứ ừ Ừ ử Ử ữ Ữ ự Ự',
    'v'  => 'V',
    'w'  => 'W ŵ Ŵ ẁ Ẁ ẃ Ẃ ẅ Ẅ',
    'x'  => 'X',
    'y'  => 'Y ý Ý ÿ Ÿ ỳ Ỳ ỵ Ỵ ỷ Ỷ ỹ Ỹ ŷ Ŷ',
    'z'  => 'Z ź Ź ż Ż ž Ž',
    'ae' => 'æ Æ Ǽ ǽ',
    'ð'  => 'Ð',
    'ə'  => 'Ə',
    'ij' => 'ĳ Ĳ',
    'ŋ'  => 'Ŋ',
    'oe' => 'œ Œ',
    'þ'  => 'Þ',
    
  // Greek
    
    'α'  => 'Α ά Ά',
    'β'  => 'Β',
    'γ'  => 'Γ',
    'δ'  => 'Δ',
    'ε'  => 'Ε έ Έ',
    'ζ'  => 'Ζ',
    'η'  => 'Η ή Ή',
    'θ'  => 'Θ',
    'ι'  => 'Ι ί Ί ϊ Ϊ ΐ',
    'κ'  => 'Κ',
    'λ'  => 'Λ',
    'μ'  => 'Μ µ',
    'ν'  => 'Ν',
    'ξ'  => 'Ξ',
    'ο'  => 'Ο ό Ό',
    'π'  => 'Π',
    'ρ'  => 'Ρ',
    'σ'  => 'Σ ς',
    'τ'  => 'Τ',
    'υ'  => 'Υ ύ Ύ ϋ Ϋ ΰ',
    'φ'  => 'Φ',
    'χ'  => 'Χ',
    'ψ'  => 'Ψ',
    'ω'  => 'Ω ώ Ώ',
    
  // Cyrillic
    
    'а'  => 'А',
    'б'  => 'Б',
    'в'  => 'В',
    'г'  => 'Г ґ Ґ ғ Ғ',
    'д'  => 'Д',
    'е'  => 'Е',
    'ж'  => 'Ж җ Җ',
    'з'  => 'З',
    'и'  => 'И',
    'й'  => 'Й',
    'к'  => 'К қ Қ ҝ Ҝ',
    'л'  => 'Л',
    'м'  => 'М',
    'н'  => 'Н ң Ң',
    'о'  => 'О',
    'п'  => 'П',
    'р'  => 'Р',
    'с'  => 'С',
    'т'  => 'Т',
    'у'  => 'У',
    'ү'  => 'Ү',
    'ұ'  => 'Ұ',
    'ф'  => 'Ф',
    'х'  => 'Х ҳ Ҳ',
    'ц'  => 'Ц',
    'ч'  => 'Ч ҹ Ҹ',
    'ш'  => 'Ш',
    'щ'  => 'Щ',
    'ъ'  => 'Ъ',
    'ы'  => 'Ы',
    'ь'  => 'Ь',
    'э'  => 'Э',
    'ю'  => 'Ю',
    'я'  => 'Я',
    'ё'  => 'Ё',
    'ђ'  => 'Ђ',
    'ѓ'  => 'Ѓ',
    'є'  => 'Є',
    'ѕ'  => 'Ѕ',
    'і'  => 'І',
    'ї'  => 'Ї',
    'ј'  => 'Ј',
    'љ'  => 'Љ',
    'њ'  => 'Њ',
    'ћ'  => 'Ћ',
    'ќ'  => 'Ќ',
    'ў'  => 'Ў',
    'џ'  => 'Џ',
    'һ'  => 'Һ',
    'ә'  => 'Ә',
    'ө'  => 'Ө',
    
  );

  $LCAS_lang['char_replacement_set'][3] = array(
  // 3 : case sensitive, accents insensitive
    
  // Latin
    
    'a'  => 'à â á ã ä å ā ă ą ǻ ạ ả ấ ầ ẩ ẫ ậ ắ ằ ẳ ẵ ặ @',
    'A'  => 'À Â Á Ã Ä Å Ā Ă Ą Ǻ Ạ Ả Ấ Ầ Ẩ Ẫ Ậ Ắ Ằ Ẳ Ẵ Ặ',
    'c'  => 'ç ć ĉ ċ č',
    'C'  => 'Ç Ć Ĉ Ċ Č',
    'd'  => 'ď đ',
    'D'  => 'Ď Đ',
    'e'  => 'è é ê ë ē ĕ ė ę ě ẹ ẻ ẽ ế ề ể ễ ệ',
    'E'  => 'È É Ê Ë Ē Ĕ Ė Ę Ě Ẹ Ẻ Ẽ Ế Ề Ể Ễ Ệ',
    'f'  => 'ƒ',
    'g'  => 'ĝ ğ ġ ģ',
    'G'  => 'Ĝ Ğ Ġ Ģ',
    'h'  => 'ĥ ħ',
    'H'  => 'Ĥ Ħ',
    'i'  => 'ì í î ï ĩ ī ĭ į ǐ ỉ ị ı',
    'I'  => 'Ì Í Î Ï Ĩ Ī Ĭ Į Ǐ Ỉ Ị İ',
    'j'  => 'ĵ',
    'J'  => 'Ĵ',
    'k'  => 'ķ',
    'K'  => 'Ķ',
    'l'  => 'ĺ ļ ľ ŀ ł',
    'L'  => 'Ĺ Ļ Ľ Ŀ Ł',
    'n'  => 'ñ ń ņ ň ŉ',
    'N'  => 'Ñ Ń Ņ Ň',
    'o'  => 'ò ó ô õ ö ø ō ŏ ő ơ ǒ ǿ ọ ỏ ố ồ ổ ỗ ộ ớ ờ ở ỡ ợ',
    'O'  => 'Ò Ó Ô Õ Ö Ø Ō Ŏ Ő Ơ Ǒ Ǿ Ọ Ỏ Ố Ồ Ổ Ỗ Ộ Ớ Ờ Ở Ỡ Ợ',
    'q'  => 'ĸ',
    'r'  => 'ŕ ŗ ř',
    'R'  => 'Ŕ Ŗ Ř',
    's'  => 'ś ŝ ş š ſ',
    'S'  => 'Ś Ŝ Ş Š',
    'ss' => 'ß',
    't'  => 'ţ ť ŧ',
    'T'  => 'Ţ Ť Ŧ',
    'u'  => 'ù ú û ü ũ ū ŭ ů ű ų ǔ ǖ ǘ ǚ ǜ ư ụ ủ ứ ừ ử ữ ự',
    'U'  => 'Ù Ú Û Ü Ũ Ū Ŭ Ů Ű Ų Ǔ Ǖ Ǘ Ǚ Ǜ Ư Ụ Ủ Ứ Ừ Ử Ữ Ự',
    'w'  => 'ŵ ẁ ẃ ẅ',
    'W'  => 'Ŵ Ẁ Ẃ Ẅ',
    'y'  => 'ý ÿ ỳ ỵ ỷ ỹ ŷ',
    'Y'  => 'Ý Ÿ Ỳ Ỵ Ỷ Ỹ Ŷ',
    'z'  => 'ź ż ž',
    'Z'  => 'Ź Ż Ž',
    'ae' => 'ǽ',
    'AE' => 'Ǽ',
    'ij' => 'ĳ',
    'IJ' => 'Ĳ',
    'oe' => 'œ',
    'OE' => 'Œ',
    
  // Greek
    
    'α'  => 'ά',
    'Α'  => 'Ά',
    'ε'  => 'έ',
    'Ε'  => 'Έ',
    'μ'  => 'µ',
    'η'  => 'ή',
    'Η'  => 'Ή',
    'ι'  => 'ί ϊ ΐ',
    'Ι'  => 'Ί Ϊ',
    'ο'  => 'ό',
    'Ο'  => 'Ό',
    'σ'  => 'ς',
    'υ'  => 'ύ ϋ ΰ',
    'Υ'  => 'Ύ Ϋ',
    'ω'  => 'ώ',
    'Ω'  => 'Ώ',
    
  // Cyrillic
    
    'г'  => 'ґ ғ',
    'Г'  => 'Ґ Ғ',
    'ж'  => 'җ',
    'Ж'  => 'Җ',
    'к'  => 'қ ҝ',
    'К'  => 'Қ Ҝ',
    'н'  => 'ң',
    'Н'  => 'Ң',
    'х'  => 'ҳ',
    'Х'  => 'Ҳ',
    'ч'  => 'ҹ',
    'Ч'  => 'Ҹ',
    
  );
  // Exits immediately without changing the parameter, if the configuration
  // is set on "case sensitive and accent sensitive".
  if (!isset($Conf) or
    $Conf != 1 and
    $Conf != 2 and
    $Conf != 3
  ) return $Username;
  
  // $v remembers if the given parameter was an array or not
  $s2 = ($v = (is_array($Username))) ? $Username : array(0 => $Username);
  
  // Builds an array of characters that must be replaced
  // $rep_char is the replacement character ; $char_rep_arr is an array of 
  // characters which have to be replaced. ie :
  // if
  // $LCAS_lang['char_replacement_set'][$conf['insensitive_case_logon']]['e'] ='é è'
  // then
  // $char_rep_arr['é'] = 'e' ; $char_rep_arr['è'] = 'e'.
  $char_rep_arr = array();
  foreach (
   $LCAS_lang['char_replacement_set'][$Conf]
   as $rep_char => $char_rep_list
  ) {
    $t = explode(' ', $char_rep_list);
    foreach ($t as $c) $char_rep_arr[$c] = $rep_char;
  }
  
  // Replacement in each string of $s2 of the characters
  // that needs to be replaced
  $r = array();
  foreach ($s2 as $s) {
    $t = LCAS_mbStringToArray($s); $t2 ='';
    foreach ($t as $c) {
      if (array_key_exists($c, $char_rep_arr))
       $t2.= $char_rep_arr[$c];
      else
       $t2.= $c;
    }
    $r[] = $t2;
  }
  
  // Return of the result
  if ($v) return $r;
  else return $r[0];
}












/* Function called from main.inc.php to send validation email */
function LCAS_SendMail2User($typemail, $id, $username, $password, $email, $confirm)
{
  global $conf;

  $conf_LCAS= unserialize($conf['LoginCaseAccentsSensitivity']);
  
	include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
  
	$infos1_perso = "";
  $infos2_perso = "";

/* We have to get the user's language in database */
  $query ='
SELECT user_id, language
FROM '.USER_INFOS_TABLE.'
WHERE user_id = '.$id.'
;';
  $data = pwg_db_fetch_assoc(pwg_query($query));

/* Check if user is already registered (profile changing) - If not (new registration), language is set to current gallery language */
  if (empty($data))
  {
/* And switch gallery to this language before using personalized and multilangual contents */
    $language = pwg_get_session_var( 'lang_switch', $user['language'] );
    switch_lang_to($language);
  }
  else
  {
/* And switch gallery to this language before using personalized and multilangual contents */
    $language = $data['language']; /* Usefull for debugging */
    switch_lang_to($data['language']);
    load_language('plugin.lang', LCAS_PATH);
  }

  switch($typemail)
  {
    case 1:
      $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Add of %s', stripslashes($username)));
      $password = $password <> '' ? $password : l10n('LCAS_empty_pwd');
      
      if (isset($conf_LCAS[9]) and $conf_LCAS[9] <> '')
      {
        if (function_exists('get_user_language_desc'))
        {
          $infos1_perso = get_user_language_desc($conf_LCAS[9])."\n\n";
        }
        else $infos1_perso = l10n($conf_LCAS[9])."\n\n"; 
      }
      
      break;
      
    case 2:
      $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Update of %s', stripslashes($username)));
      $password = $password <> '' ? $password : l10n('LCAS_empty_pwd');

      break;
        
    case 3:
      $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Update of %s', stripslashes($username)));
      $password = $password <> '' ? $password : l10n('LCAS_no_update_pwd');

      break;
  }

  if (isset($conf_LCAS[0]) and $conf_LCAS[0] == 'true')
  {
    $infos1 = array(
      get_l10n_args('infos_mail %s', stripslashes($username)),
      get_l10n_args('User: %s', stripslashes($username)),
      get_l10n_args('Password: %s', $password),
      get_l10n_args('Email: %s', $email),
      get_l10n_args('', ''),
    );
  }


  if ( isset($conf_LCAS[1]) and $conf_LCAS[1] == 'true' and $confirm)
  {
    $infos2 = array
    (
      get_l10n_args('Link: %s', AddConfirmMail($id, $email)),
      get_l10n_args('', ''),
    );

    if (isset($conf_LCAS[10]) and $conf_LCAS[10] <> '')
    {
      if (function_exists('get_user_language_desc'))
      {
        $infos2_perso = get_user_language_desc($conf_LCAS[10])."\n\n";
      }
      else $infos2_perso = l10n($conf_LCAS[10])."\n\n";
    }
  }

/* Sending the email with subject and contents */
  pwg_mail($email, array(
    'subject' => $subject,
    'content' => (isset($infos1) ? $infos1_perso.l10n_args($infos1)."\n\n" : "").(isset($infos2) ? $infos2_perso.l10n_args($infos2)."\n\n" : "").get_absolute_root_url(),
  ));

/* Switching back to default language */
switch_lang_back();
}

/* Function called from LCAS_admin.php and main.inc.php to get the plugin version and name */
function LCAS_PluginInfos($dir)
{
  $path = $dir;

  $plg_data = implode( '', file($path.'main.inc.php') );
  if ( preg_match("|Plugin Name: (.*)|", $plg_data, $val) )
  {
    $plugin['name'] = trim( $val[1] );
  }
  if (preg_match("|Version: (.*)|", $plg_data, $val))
  {
    $plugin['version'] = trim($val[1]);
  }
  if ( preg_match("|Plugin URI: (.*)|", $plg_data, $val) )
  {
    $plugin['uri'] = trim($val[1]);
  }
  if ($desc = load_language('description.txt', $path.'/', array('return' => true)))
  {
    $plugin['description'] = trim($desc);
  }
  elseif ( preg_match("|Description: (.*)|", $plg_data, $val) )
  {
    $plugin['description'] = trim($val[1]);
  }
  if ( preg_match("|Author: (.*)|", $plg_data, $val) )
  {
    $plugin['author'] = trim($val[1]);
  }
  if ( preg_match("|Author URI: (.*)|", $plg_data, $val) )
  {
    $plugin['author uri'] = trim($val[1]);
  }
  if (!empty($plugin['uri']) and strpos($plugin['uri'] , 'extension_view.php?eid='))
  {
    list( , $extension) = explode('extension_view.php?eid=', $plugin['uri']);
    if (is_numeric($extension)) $plugin['extension'] = $extension;
  }
// IMPORTANT SECURITY !
  $plugin = array_map('htmlspecialchars', $plugin);

  return $plugin ;
}

// Tri les doublons
function CompareTransformedUser($a, $b)
{
	return strcmp($a['transformed'], $b['transformed']);
}

// Fonctionnel mais optimisable
function LCAS_GetDuplicates($source) {
	$users      = array();
	$duplicates = array();
	
	// Liste des utilisateurs uniques
	foreach($source as $user) {
		if (isset($users[$user['transformed']])) {
			$users[$user['transformed']] += 1;
		}
		else {
			$users[$user['transformed']] = 1;
		}
	}
	
	// On récupère les doublons
	foreach($source as $user) {
		if ($users[$user['transformed']] > 1) {
			array_push($duplicates, $user);
		}
	}
	
	// Trier le tableau
	usort($duplicates, 'CompareTransformedUser');
	
	return $duplicates;
}

/* Get all users to display the number of days since their last visit */
function LCAS_get_user_list($rule)
{
	global $conf, $page;
  
  $users = array();

	/* search users depending expiration date */
  $query = '
SELECT DISTINCT u.'.$conf['user_fields']['id'].' AS id,
                u.'.$conf['user_fields']['username'].' AS username,
                u.'.$conf['user_fields']['email'].' AS email
FROM '.USERS_TABLE.' AS u
;';

	$result = pwg_query($query);
      
  while ($row = pwg_db_fetch_assoc($result))
  {
  	$user = $row;
  	$user['transformed'] = LCAS_change_case($user['username'], $rule); 
    array_push($users, $user);
	}

	return LCAS_GetDuplicates($users);
}

function LCAS_clean_obsolete_files()
{
  if (file_exists(LCAS_PATH.'obsolete.list')
    and $old_files = file(LCAS_PATH.'obsolete.list', FILE_IGNORE_NEW_LINES)
    and !empty($old_files))
  {
    array_push($old_files, 'obsolete.list');
    foreach($old_files as $old_file)
    {
      $path = LCAS_PATH.$old_file;
      if (is_file($path))
      {
        @unlink($path);
      }
    }
  }
}

/**
 * Function called from main.inc.php - Returns exiting lowercase username in database
 * 
 * @param : $username typed in by user for identification
 * 
 * @return : lowercase $username found in database
 * 
 */
function LCAS_SearchUsername($username)
{
  global $conf;
  
  if (isset($username))
  {
    $query = "
SELECT ".$conf['user_fields']['username']."
FROM ".USERS_TABLE."
WHERE LOWER(".$conf['user_fields']['username'].") = '".strtolower($username)."'
LIMIT 1;";

    list($username) = pwg_db_fetch_assoc(pwg_query($query));;

    return isset($username) ? $username : '';
  }
}


// DebugLog function
function DebugLog($var1, $var2, $var3, $var4, $var5)
{
   $fo=fopen (LCAS_PATH.'admin/debuglog.txt','a') ;
   fwrite($fo,"======================\n") ;
   fwrite($fo,'le ' . date('D, d M Y H:i:s') . "\r\n");
   fwrite($fo, "\n" . $var1 . "\r\n") ;
   fwrite($fo, "\n" . $var2 . "\r\n") ;
   fwrite($fo, "\n" . $var3 . "\r\n") ;
   fwrite($fo, "\n" . $var4 . "\r\n") ;
   fwrite($fo, "\n" . $var5 . "\r\n") ;
   fclose($fo) ;
}
?>